import es
import cmdlib
import gamethread
import popuplib
import urllib2
from path import path
from time import gmtime, strftime

#Globals:
useAddon = 0
newVersion = 0
roundCounter = 0
delayCounter = 0
addonPath = es.getAddonPath("remote_mapcontrol")
curMap = es.ServerVar('eventscripts_currentmap')

#Lists:
adminList = []
errorList = []

#Dicts:
entDict = {}
rmNames = {} #[<EntityIndex>]: EntityName
rmIndexes = {} #[<EntityName>]: EntityIndex
rmPopup = {} #[<Description>]: [cmd,description,entTarget,entInput,entValue,delay,sortInteger]
rmAutoRound = {} #[<Description>]: [cmd,description,entTarget,entInput,entValue,delay,sortInteger]
rmAutoSpawn = {} #[<Description>]: [cmd,description,entTarget,entInput,entValue,delay,sortInteger]

#AddonInfo:
info = es.AddonInfo() 
info.name     	= "Remote Mapcontrol" 
info.basename 	= "remote_mapcontrol"
info.version  	= es.ServerVar("rm_version")
info.url      	= "http://addons.eventscripts.com/addons/view/RemoteMapcontrol" 
info.description = "Plugin to control maps remotly"
info.author   	= "Steam: TheSpeedFreak | Eventscripts Forum: SpeedFreak"

#Version:
def checkVersion():
	global newVersion
	try:
		file = urllib2.urlopen('http://www.nextgenerationgaming.de/addons/remote_mapcontrol/version.txt')
		version = file.readline()
		file.close()
		if version != es.ServerVar('rm_version'):
			newVersion = 1
			for userid in es.getUseridList(): whisper(userid,'#redA new version is available!')
	except urllib2.URLError:
		pass

def load():
	global useAddon, entDict
	es.set('rm_version','v1.1')
	es.makepublic('rm_version')
	es.regsaycmd('!remote','remote_mapcontrol/triggerRemote','Opens remote menu')
	cmdlib.registerServerCommand('rm_fire',addControlFire,'Syntax: rm_fire <description> <popup/round/spawn> <delay> <entity name/entity index/class name> <input> (<value>)')
	cmdlib.registerServerCommand('rm_setvalue',addControlEntityValue,'Syntax: rm_setvalue <description> <popup/round/spawn> <delay> <entity name/entity index/class name> <ValueName> <Value>')
	es.set('rm_admins',"")
	es.set('rm_echo',1)
	es.set('rm_errors',1)
	es.set('rm_update',1)
	es.server.queuecmd('es_xmexec ../addons/eventscripts/remote_mapcontrol/config.cfg')
	es.server.queuecmd('mp_restartgame 1')
	if path.isfile(path(addonPath+'/maps/%s.cfg' % curMap)):
		useAddon = 1
		es.server.queuecmd('es_xmexec ../addons/eventscripts/remote_mapcontrol/maps/'+curMap+'.cfg')
		entDict = es.createentitylist()
	if es.ServerVar('rm_update'): checkVersion()
	gamethread.delayed(0.5,setVars)

def unload():
	if es.ServerVar('rm_errors'): saveErrorList(curMap)
	es.unregsaycmd('!remote')
	cmdlib.unregisterServerCommand('rm_fire')
	cmdlib.unregisterServerCommand('rm_setvalue')
	for userid in es.getUseridList(): whisper(userid,'#blue%s #greensuccessfully unloaded!' % es.ServerVar('rm_version'))

def es_map_start(ev):
	global curMap, useAddon, entDict
	if es.ServerVar('rm_errors'): saveErrorList(curMap)
	curMap = es.ServerVar('eventscripts_currentmap')
	useAddon = 0
	del errorList[:]
	entDict.clear()
	rmNames.clear()
	rmIndexes.clear()
	rmPopup.clear()
	rmAutoSpawn.clear()
	rmAutoRound.clear()
	if path.isfile(path(addonPath+'/maps/%s.cfg' % curMap)):
		useAddon = 1
		es.server.queuecmd('es_xmexec ../addons/eventscripts/remote_mapcontrol/maps/'+curMap+'.cfg')
		entDict = es.createentitylist()
	if es.ServerVar('rm_update'): checkVersion()

def round_start(ev):
	global roundCounter, delayCounter, entDict
	if useAddon:
		delayCounter += 1
		entDict = es.createentitylist()
		i = 0
		for entity in entDict:
			name = es.entitygetvalue(entity,'targetname')
			if name != '':
				entity = int(entity)
				rmNames[entity] = name
				rmIndexes[name] = entity
			else:
				i += 1
				name = ('__rmManager%s' % i)
				es.setentityname(entity,name)
				entity = int(entity)
				rmNames[entity] = name
		if len(rmAutoRound) > 0: gamethread.delayed(0.2,runAutoRoundCommands)
	if es.ServerVar('rm_update') and newVersion:
		roundCounter += 1
		if roundCounter == 5:
			for userid in es.getUseridList(): whisper(userid,'#redA new version is available!')
			roundCounter = 0

def player_spawn(ev):
	if useAddon:
		if len(rmAutoSpawn) > 0: gamethread.delayed(0.2,runAutoSpawnCommands,int(ev['userid']))
				
def setVars():
	global adminList
	adminList = str(es.ServerVar("rm_admins")).split(';')
	for userid in es.getUseridList(): whisper(userid,'#blue%s #greensuccessfully loaded!' % es.ServerVar('rm_version'))

def convertEntData(entity,mode):
	#Mode 1: Name ---> Index
	#Mode 2: Index ---> Name
	if mode == 1:
		try:
			entity = int(entity)
			return [entity]
		except ValueError:
			if entity in rmIndexes:
				return [rmIndexes[entity]]
			else:
				return es.createentitylist(entity)
	elif mode == 2:
		try:
			entity = int(entity)
			if entity in rmNames: return rmNames[entity]
		except ValueError:
			return entity
	return None

def executeCommands(userid,data):
	for x in data:
		if x[0] == 'rm_fire':
			target = convertEntData(x[2],2)
			es.fire(userid,target,x[3],x[4],x[5])
		elif x[0] == 'rm_setvalue':
			targetList = convertEntData(x[2],1)
			if targetList != None:
				for target in targetList:
					if target in entDict:
						if x[5] > 0:
							gamethread.delayed(x[5],executeCommandsDelayed,(delayCounter,[target,x[3],x[4]]))
						else:
							es.entitysetvalue(target,x[3],x[4])
					else:
						error(None,'The entity with index [%s] does not exist!' % target)
						error(None,'Affected Code: rm_setvalue "%s" "..." "%s" "%s" "%s" "%s"' % (x[1],x[5],target,x[3],x[4]))

def executeCommandsDelayed(delayCheck,cmds):
	if delayCheck == delayCounter: es.entitysetvalue(cmds[0],cmds[1],cmds[2])

def runAutoSpawnCommands(userid):
	tempDict = {}
	for description in rmAutoSpawn: tempDict[description] = rmAutoSpawn[description][0][6]
	for description,i in sorted(tempDict.iteritems(), key=lambda (k,v): (v,k)): executeCommands(userid,rmAutoSpawn[description])

def runAutoRoundCommands():
	playerlist = es.getUseridList()
	if len(playerlist) > 0:
		userid = playerlist[0]
		tempDict = {}
		for description in rmAutoRound: tempDict[description] = rmAutoRound[description][0][6]
		for description,i in sorted(tempDict.iteritems(), key=lambda (k,v): (v,k)): executeCommands(userid,rmAutoRound[description])

def saveErrorList(mapname):
	if len(errorList) > 0:
		clearFile(addonPath+'/errors/'+mapname+'.txt')
		file = open(addonPath+'/errors/'+mapname+'.txt','a')
		file.write('Log created: %s\n' % str(strftime("%d.%m.%Y - %H:%M:%S")))
		file.write('------------------------------------------------------------------------------------------------------------------------------\n')
		i = 0
		for text in errorList:
			i += 1
			file.write(text+'\n')
			if i == 2:
				file.write('------------------------------------------------------------------------------------------------------------------------------\n')
				i = 0
		file.close()

def clearFile(filename):
	file = open(filename,'w')
	file.close()

def triggerRemote():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	if steamid in adminList:
		popupCreate(userid,1)
	else:
		error(userid,'#greenYou have no access!')

def popupCreate(userid,page):
	playSound(userid,1)
	temp = popuplib.easymenu('remote_mapcontrol',None,popupRemote)
	temp.settitle('Remote Mapcontrol')
	temp.setdescription('Version: %s\nMap: %s\nPopup Commands: %s\nRound Commands: %s\nSpawn Commands: %s' % (es.ServerVar('rm_version'),curMap,len(rmPopup),len(rmAutoRound),len(rmAutoSpawn)))
	tempDict = {}
	for description in rmPopup: tempDict[description] = rmPopup[description][0][6]
	for description,i in sorted(tempDict.iteritems(), key=lambda (k,v): (v,k)): temp.addoption(description,description)
	temp.sendPage(userid,page)
	temp.delete()

def popupRemote(userid,choice,popupname):
	playSound(userid,1)
	data = rmPopup[choice]
	executeCommands(userid,data)
	if es.ServerVar('rm_echo') == 1:
		whisper(userid,'#greenTriggered: #blue%s' % data[0][1])
	elif es.ServerVar('rm_echo') == 2:
		name = es.getplayername(userid)
		for admin in adminList:
			adminID = es.getuserid(admin)
			if adminID: whisper(userid,'#blue%s #greentriggered: #blue%s' % (name,data[0][1]))
	if len(rmPopup) > 9:
		popupCreate(userid,getPage(choice))
	else:
		popupCreate(userid,1)

def getPage(selection):
	return divmod(selection,7)[0]+1

def addControlFire(arguments):
	args = es.getargc()
	if args == 6 or args == 7:
		description = es.getargv(1)
		style = es.getargv(2).lower()
		delay = es.getargv(3)
		entTarget = es.getargv(4)
		entInput = es.getargv(5)
		if args == 7:
			entValue = es.getargv(6)
		else:
			entValue = None
		try:
			delay = float(delay)
		except ValueError:
			error(None,'Error: Delay [%s] is not numeric!' % delay)
			error(None,'Affected Code: rm_fire %s' % arguments)
			return
		if 'popup' in style:
			if description not in rmPopup: rmPopup[description] = []
			rmPopup[description].append(['rm_fire',description,entTarget,entInput,entValue,delay,len(rmPopup)])
		if 'round' in style:
			if description not in rmAutoRound: rmAutoRound[description] = []
			rmAutoRound[description].append(['rm_fire',description,entTarget,entInput,entValue,delay,len(rmAutoRound)])
		if 'spawn' in style:
			if description not in rmAutoSpawn: rmAutoSpawn[description] = []
			rmAutoSpawn[description].append(['rm_fire',description,entTarget,entInput,entValue,delay,len(rmAutoSpawn)])
	else:
		if args == 1: arguments = ''
		error(None,'Syntax Error!')
		error(None,'Affected Code: rm_fire %s' % arguments)

def addControlEntityValue(arguments):
	args = es.getargc()
	if args == 7:
		description = es.getargv(1)
		style = es.getargv(2).lower()
		delay = es.getargv(3)
		entTarget = es.getargv(4)
		entInput = es.getargv(5)
		entValue = es.getargv(6)
		try:
			delay = float(delay)
		except ValueError:
			error(None,'Error: Delay [%s] is not numeric!' % delay)
			error(None,'Affected Code: rm_setvalue %s' % arguments)
			return
		if 'popup' in style:
			if description not in rmPopup: rmPopup[description] = []
			rmPopup[description].append(['rm_setvalue',description,entTarget,entInput,entValue,delay,len(rmPopup)])
		if 'round' in style:
			if description not in rmAutoRound: rmAutoRound[description] = []
			rmAutoRound[description].append(['rm_setvalue',description,entTarget,entInput,entValue,delay,len(rmAutoRound)])
		if 'spawn' in style:
			if description not in rmAutoSpawn: rmAutoSpawn[description] = []
			rmAutoSpawn[description].append(['rm_setvalue',description,entTarget,entInput,entValue,delay,len(rmAutoSpawn)])	
	else:
		if args == 1: arguments = ''
		error(None,'Syntax Error!')
		error(None,'Affected Code: rm_setvalue %s' % arguments)

def whisper(userid,msg):
	msg = msg.replace('#black','\x07000000')
	msg = msg.replace('#blue','\x0720B2AA')
	msg = msg.replace('#red','\x07FF3D3D')
	es.tell(userid,'#multi','\x07000000[\x0720B2AARMC\x07000000] %s' % str(msg))

def error(userid,msg):
	if userid != None:
		msg = msg.replace('#black','\x07000000')
		msg = msg.replace('#blue','\x0720B2AA')
		es.tell(userid,'#multi','\x07000000[\x0720B2AARMC\x07000000] %s' % str(msg))
		playSound(userid,0)
	else:
		msg = msg.replace('#black','')
		msg = msg.replace('#green','')
		msg = msg.replace('#blue','')
		errorList.append(msg)
		es.dbgmsg(0,'[RMC] %s' % str(msg))

def playSound(userid,number):
	#0 = Denied
	#1 = Access
	if number == 0: es.playsound(userid,'buttons/button11.wav',1.0)
	if number == 1: es.playsound(userid,'UI/buttonclick.wav',1.0)